Index: branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1049)
+++ branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1050)
@@ -1229,5 +1229,5 @@
 #if ALIGNED_BUMPING
 // Function outputs a picture, and marks it as not needed for output.
-Void TAppDecTop::xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerIdx, Int &pocLastDisplay, DpbStatus &dpbStatus )
+Void TAppDecTop::xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus )
 {
   if ( reconFile )
@@ -1242,5 +1242,5 @@
 #endif
     TComPicYuv* pPicCYuvRec = pic->getPicYuvRec();
-    m_acTVideoIOYuvReconFile[layerIdx].write( pPicCYuvRec, m_outputColourSpaceConvert,
+    m_acTVideoIOYuvReconFile[layerId].write( pPicCYuvRec, m_outputColourSpaceConvert,
       conf.getWindowLeftOffset()  * xScal + defDisp.getWindowLeftOffset(),
       conf.getWindowRightOffset() * xScal + defDisp.getWindowRightOffset(),
@@ -1266,5 +1266,5 @@
 #endif
 #if FIX_ALIGN_BUMPING
-    dpbStatus.m_numPicsInSubDpb[dpbStatus.m_layerIdToSubDpbIdMap[layerIdx]]--;
+    dpbStatus.m_numPicsInSubDpb[dpbStatus.m_layerIdToSubDpbIdMap[layerId]]--;
 #else
     dpbStatus.m_numPicsInSubDpb[layerIdx]--;
@@ -1482,5 +1482,5 @@
   for( Int dpbLayerCtr = 0; dpbLayerCtr < dpbStatus.m_numLayers; dpbLayerCtr++)
   {
-    Int layerIdx  = dpbStatus.m_targetDecLayerIdList[dpbLayerCtr];
+    Int layerId  = dpbStatus.m_targetDecLayerIdList[dpbLayerCtr];
 #else
   for( Int layerIdx = 0; layerIdx < dpbStatus.m_numLayers; layerIdx++)
@@ -1488,10 +1488,10 @@
 #endif
     // Check if picture with pocValue is present.
-    it = find( listOfPocsInEachLayer[layerIdx].begin(), listOfPocsInEachLayer[layerIdx].end(), pocValue );
-    if( it != listOfPocsInEachLayer[layerIdx].end() )  // picture found.
-    {
-      Int picPosition = std::distance( listOfPocsInEachLayer[layerIdx].begin(), it );
+    it = find( listOfPocsInEachLayer[layerId].begin(), listOfPocsInEachLayer[layerId].end(), pocValue );
+    if( it != listOfPocsInEachLayer[layerId].end() )  // picture found.
+    {
+      Int picPosition = std::distance( listOfPocsInEachLayer[layerId].begin(), it );
       Int j;
-      for(j = 0, iterPic = m_acTDecTop[layerIdx].getListPic()->begin(); j < listOfPocsPositionInEachLayer[layerIdx][picPosition]; j++) // Picture to be output
+      for(j = 0, iterPic = m_acTDecTop[layerId].getListPic()->begin(); j < listOfPocsPositionInEachLayer[layerId][picPosition]; j++) // Picture to be output
       {
         iterPic++;
@@ -1499,5 +1499,5 @@
       TComPic *pic = *iterPic;
 
-      xOutputAndMarkPic( pic, m_pchReconFile[layerIdx], layerIdx, m_aiPOCLastDisplay[layerIdx], dpbStatus );
+      xOutputAndMarkPic( pic, m_pchReconFile[layerId], layerId, m_aiPOCLastDisplay[layerId], dpbStatus );
 
 #if CONFORMANCE_BITSTREAM_MODE
@@ -1524,8 +1524,8 @@
 #endif
 
-      listOfPocsInEachLayer[layerIdx].erase( it );
-      listOfPocsPositionInEachLayer[layerIdx].erase( listOfPocsPositionInEachLayer[layerIdx].begin() + picPosition );
+      listOfPocsInEachLayer[layerId].erase( it );
+      listOfPocsPositionInEachLayer[layerId].erase( listOfPocsPositionInEachLayer[layerId].begin() + picPosition );
 #if FIX_ALIGN_BUMPING
-      dpbStatus.m_numPicsInSubDpb[dpbStatus.m_layerIdToSubDpbIdMap[layerIdx]]--;
+      dpbStatus.m_numPicsInSubDpb[dpbStatus.m_layerIdToSubDpbIdMap[layerId]]--;
 #endif
     }
Index: branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1049)
+++ branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1050)
@@ -110,5 +110,5 @@
   Void flushAllPictures(Int layerId, Bool outputPictures);
 
-  Void xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerID, Int &pocLastDisplay, DpbStatus &dpbStatus);
+  Void xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus);
 #if POC_RESET_IDC_DECODER
   Void outputAllPictures(Int layerId, Bool notOutputCurrAu);